#define AUTO_DLLMAIN
#include <DynRPG/DynRPG.h>

void unpauseBattle();
void pauseBattle();

/*
FEATURES:
=========
Makes an LP system. That is, removes 1MP when a character dies, and if the character has 0MP, adds a Death2 status, which, by normal means,
can't be removed (that is up to you to make unremovable).
So remember that the "heal everything" command heals EVERYTHING.

In RomaSaGa, when an actor had 0LP, that actor was then removed from the party, and NEVER returned (perma-death). You can do that if you want
just by using a common event that checks if MP==0.
*/

//Asdf: RPG::Actor->partyMember[index]; -- RPG::monsters[index]; aww yeah!!!

//const int DEATH2=2;

bool onBattlerActionDone(RPG::Battler * battler, bool success)	{
    if (success) {

        if (battler->action->target == 1){
            int t_id = battler->action->targetId;
            if(RPG::Actor::partyMember(t_id) != NULL) {

                if (RPG::Actor::partyMember(t_id)->hp<=0 && RPG::Actor::partyMember(t_id)->conditions[2]==0){
                    RPG::Actor::partyMember(t_id)->mp--;
                }
            }
        }

        else if(battler->action->target == 3){
            int t_id = battler->action->targetId;
            if(RPG::monsters[t_id] != NULL) {
                //if (RPG::monsters[t_id]->hp<=0){
                //    RPG::monsters[t_id]->mp--;
                //}
            }
        }

        else if(battler->action->target == 2){
            for(int i=0;i<4;i++){
                if(RPG::Actor::partyMember(i) != NULL) {
                    if (RPG::Actor::partyMember(i)->hp<=0 && RPG::Actor::partyMember(i)->conditions[2]==0){
                        RPG::Actor::partyMember(i)->mp--;
                    }
                }
            }
        }

        else if(battler->action->target == 4){

            for(int i=0;i<8;i++){
                if(RPG::monsters[i] != NULL) {
                    //if (RPG::monsters[i]->hp<=0 && RPG::monsters[i]->conditions[2]==0){
                        //RPG::monsters[i]->mp--;
                    //}
                }
            }
        }

    }
    return true; // It's okay that the battler is drawn, so we return true. Don't forget that!
}
// This handler is called after a battler is drawn
bool onBattlerDrawn(RPG::Battler *battler, bool isMonster, int id) {
    if (battler->mp<=0 && battler->conditions[2]==0){
        //battler->animationId = 5;
        battler->conditions[2] = 1;
        battler->damagePopup ("Muerto");
        battler->damagePopupTimer = 120;
    }
    //if (isMonster == true && battler->mp<=0 && battler->conditions[2]!=0){ //
    //    RPG::Monster *monster = (RPG::Monster *)battler; // First, we cast the "battler" to a "Monster"
    //    monster->image->alpha = (battler->damagePopupTimer);
    //    if (battler->damagePopupTimer<=0){
    //        battler->hp = 0;
    //    }
    //}
    if (battler->damagePopupTimer<20 && battler->damagePopupTimer>1){
        unpauseBattle();
    } else if(battler->damagePopupTimer>=1){
        pauseBattle();
    }
    return true; // It's okay that the battler is drawn, so we return true. Don't forget that!
}

// Handler called on startup
bool onStartup(char *pluginName){
    *reinterpret_cast<short *>(0x48FA57) = 0x9090;
    return true;
}
/*
bool onSetSwitch(int id, bool value) {
    if (id == 368){
        keybd_event(VK_F4, 0, 0, 0); // simulate F4 key down
        keybd_event(VK_F4, 0, KEYEVENTF_KEYUP, 0); // simulate F4 key up
    }
    if (id == 367){
        keybd_event(VK_F5, 0, 0, 0); // simulate F5 key down
        keybd_event(VK_F5, 0, KEYEVENTF_KEYUP, 0); // simulate F5 key up
    }
    return true;
}
*/
void unpauseBattle(){
    RPG::battleSpeed = 100;
}

void pauseBattle(){
    RPG::battleSpeed = 0;
}

